// var proc = cockpit.spawn(["ping", "-c", "4", address.val()]);
// proc.done(ping_success);
// proc.stream(ping_output);
// proc.fail(ping_fail);

const $list = $('#list');
const $fileContent = $('#filecontent');
const logDir = '/path/to/logiles/';
const logableExtensions = ['txt', 'log'];
let currentDir = '';


function exec(cmd) {
    const proc = cockpit.spawn(cmd);
    const streamed = [];

    return new Promise((resolve, reject) => {
        proc.stream((data) => {
            streamed.push(data);
        });
        // resolve
        proc.done(() => {
            resolve(streamed);
        });
        // reject on fail
        proc.fail(reject);
    });
}


function isLogableFile(extension) {
    if(logableExtensions.indexOf(extension) > -1) {
        return true;
    }
    return false;
}


class ListDirectory {

    constructor(logPath) {
        this.logPath = logPath;
    }

    getDir(path = '') {
        let cmdPath = this.logPath;     
        
        if(path) {
            cmdPath = cmdPath + '/' + path;
        }

        exec(['ls', cmdPath]).then((output) => {
            if(output[0]) {
                currentDir = cmdPath;
                const parsed = output[0].split(/\n/g);
                console.log(parsed);
                this.renderLines(parsed);
            }
        });
    }

    renderLines(data) {
        var lines = '';

        if(currentDir !== this.logPath) {
            lines += '<li class="">..</li>';
        }
        
        data.forEach(item => {
            if(item) {
                lines += `<li class="">${item}</li>`;
            }
        });

        $list.html(lines);
    }
}

const listDir = new ListDirectory(logDir);
listDir.getDir();


$list.on('click', 'li', (event) => {
    const $item = $(event.target);
    let text = $item.text().split('.');

    if(text.length > 1) {
        // upper dir
        if($item.text() === '..') {
            let pathSplit = currentDir.split('/');
            pathSplit.pop();
            let path = pathSplit.join('/').replace(logDir, ''); 
            listDir.getDir(path);
        }
        // files
        else {
            console.log( currentDir + '/' + $item.text() );
            if(isLogableFile(text[1])) {
                exec(['cat', currentDir + '/' + $item.text()]).then((data) => {
                    $fileContent.html(data[0].replace(/\n/g, '<br>'));
                })
            }
            else {
                $fileContent.html('Filetype not Supported.');
            }
        }
    }
    // directories
    else {
        listDir.getDir($item.text());
    }
});